
#ifndef _COMIRQ_H_
  #define _COMIRQ_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  #define R_BUF_SIZE 30000
  #define S_BUF_SIZE 30000

  typedef struct
  {
    short addr;
    short rpos;
    short rend;
    short receiveLock;
    long bytesReceived;
    long bytesReceived16;
    short spos;
    short send;
    short sendLock;
    long bytesSent;
    long bytesSent16;
    char r [R_BUF_SIZE];
    char s [S_BUF_SIZE];
  } TCOM_buf;

  extern TCOM_buf *COM_buf;

  #ifdef __cplusplus
  }
  #endif

#endif
