
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>

#include "ipxnet.h"
#include "keyb.h"
#include "win.h"
#include "tm.h"
#include "mouse.h"
#include "ipxnets.h"

#include "svga.h"
#include "car.h"
#include "csf.h"
#include "spr.h"

//#define VIDEO_MODE XVGA_320x240x256
//#define VIDEO_MODE0

//#define DEBUG_NONET

static int netslog;
static char PName [50];
static char GName [50];

//"~Arrows keys~=select item  ~Enter~=confirm select  ~Tab~=select Win       ~F1~=more",
//"~Del~=Logout  ~Esc~=Logout and exit  ~F10~=Startup network session           ~F1~=more", NULL};

static char *MyDefaultMiniHelp [] = {
"~Arrows~=select  ~Enter~=confirm    ~F1~=more",
"~Del~=logout  ~Esc~=logout & exit   ~F2 send private message ~F1~=more",
"~F10~=startup  ~Tab~=next Win    ~F1~=more", NULL};


#define NETS_LOG_MASTER 10
#define NETS_LOG_SLAVE 20
#define NETS_LOG_NONE 0
#define NETS_LOG_CREATE 1
#define NETS_LOG_JOIN 2
#define NETS_LOG_STARTUP 30


static TWIN *MyWinMiniHelp;
static TWIN *MyWinMiniStatus;

static TWIN *WinWorkGroups;
static TWIN *WinUsers;
static TWIN *WinStatus;
static TWIN *WinMessages;

static TWIN *WinYesNo;
static TWIN *WinAbout;
static TWIN *WinMain;
static TWIN *WinError;
static TWIN *WinConfirm;
static TWIN *WinWait;

static TWIN *WinSelected;


/*
char *StatusStr [4] = {"None", "Login", "Startup", "Session"};
char *LoginStr [2] = {"Enabled","Disabled"};
char *PasswordStr [2] = {"Not required","Required"};
char  *LoginResultStr [8] = {"Successfull.\n",
		       "You are alredy logged.\n",
		       "Invalid workgroup.\n",
		       "Access has been denied.\n",
		       "Login is disabled.\n",
		       "Too many work groups.\n",
		       "All users already logged.\n",
                       "No reply from the master.\n"};

*/
/*
void DisplayGroup (TNetWorkGroup *Group)
{
  int j;

  // check the workgroup descriotion
  printf ("Description  : %s\n"
          "Users counts : %i of %i\n"
          "Mode         : %s\n"
          "Login        : %s\n"
          "Password     : %s\n"
          "Users        : ", Group->Desc,
                             Group->UsersCount,
                             Group->Users7CountMax,
                             StatusStr [Group->Status],
                             LoginStr [Group->Login],
                             PasswordStr [Group->Password]);

  for (j = 0; j < NET_MAX_USERS; j++)
  {
    if (Group->Users [j].Status != NET_USER_STATUS_FREE)
    {
      printf ("%i. %s\n               ", j, Group->Users [j]. Name);
    }
  }

  printf ("\n");
}
*/


static int CmpItem (TWINItem *Item1, TWINItem *Item2)
{
  return memcmp ((void *) Item1, (void *) Item2, sizeof (TWINItem));
}

static void DisplayWorkGroups ()
{
  int i, j,k, GroupsCount;
  char group [256];
  TWINItem Item;

  GroupsCount = NET_GetWorkGroupsCount ();

  j = WinWorkGroups->contentCur;
  Item = WinWorkGroups->content [j];
  j = -1;

  WIN_deleteContent (WinWorkGroups);

  if (NetLocalWorkGroup.Status == NET_STATUS_NOTHING)
  {
    k = WIN_appendItem (WinWorkGroups, WIN_ITEMT_INPUT2, "", "", 0,
                        "Create a new workgroup", -1//NET_MAXLEN_DESC+1,
                        );
    if (Item.type == WIN_ITEMT_INPUT2)
      j = k;
  }
  else
  {
    strcat (strcpy (group,NetLocalWorkGroup.Desc),"\n");
    k = WIN_appendMenu (WinWorkGroups, "", group, 0,
                        "Your workgroup", -1//NET_MAXLEN_DESC+1,
                        );
    if (!CmpItem (&Item, &WinWorkGroups->content [k]))
      j = k;
  }

  if (GroupsCount)
  {
    for (i = 0; i < NET_MAX_WORKGROUPS; i++)
    {
      if (NetWorkGroup [i].Status != NET_STATUS_NOTHING)
      {
        strcat (strcpy (group,NetWorkGroup [i].Desc),"\n");
        k = WIN_appendMenu (WinWorkGroups, "", group, i,
                            "Join a workgroup", -1 //NET_MAXLEN_DESC+1,
                             );
        if (!CmpItem (&Item,&WinWorkGroups->content [k]))
          j = k;
      }
    }
  }

  if (j != -1)
  {
    if (Item.type != 0)
    {
      WinWorkGroups->contentCur = j;
      WinWorkGroups->content [j] = Item;
    }
  }
}


static void _DisplayUsers (TNetWorkGroup *Group)
{
  int i;
  char *UserType;
  char user [256];

  WIN_deleteContent (WinUsers);
  for (i = 0; i < NET_MAX_USERS; i++)
  {
    if (Group->Users [i].Status != NET_USER_STATUS_FREE)
    {
      if (i == 0)
        UserType = "Master";
      else
        UserType = "Slave";
      strcat (strcpy (user,Group->Users [i].Name),"\n");
      WIN_appendMenu (WinUsers, "", user, i,
                      UserType, -1 // NET_MAXLEN_NAME+1,
                      );
    }
  }
}

static void DisplayUsers ()
{
  int i;

  i = WinWorkGroups->contentCur;
  if (i == 0)
  {
    if (netslog == NETS_LOG_NONE)
      WIN_deleteContent (WinUsers);
    if ((netslog == NETS_LOG_MASTER) || (netslog == NETS_LOG_SLAVE))//WinWorkGroups->content [i].type != WIN_ITEMT_INPUT2)
    {
      WinUsers->selectable = 1;
      _DisplayUsers (&NetLocalWorkGroup);
    }
  }
  else
  {
    if ((netslog !=NETS_LOG_CREATE) && (netslog != NETS_LOG_JOIN))
    {
      WinUsers->selectable = 0;
      _DisplayUsers (&NetWorkGroup [i-1]);
    }

  }
}


typedef struct
{
  char Mes [256];
} SData;


#define MESSAGE_LOCAL 0
#define MESSAGE_EXTERN 1


static void InsertMessage (char *User, char *Message, char *Status, int Type)
{
  char _User [WIN_ITEMLEN];
//  int itemlen;
  int itemtype;
  int itempos;
  char *s;

  if (Type == MESSAGE_LOCAL)
  {
    itemtype = WIN_ITEMT_INPUT2;
    itempos = -1;
  }
  else
  {
    itemtype = WIN_ITEMT_MENU;
    itempos = WinMessages->contentCount-1;
  }
  strcpy (_User, User);
  s = strchr (_User, '\n');
  if (s != NULL)
    s = 0;
  strcat (_User, ": ");
//  itemlen = WinMessages->Size_X - strlen (_User) - strlen (Message) - 2;
  WIN_insertItem (WinMessages, itempos, itemtype, _User, Message, -1, Status, -1);
}



static void DisplayMessages ()
{
  int i, j = 0, k;
  SData SD;

  if (NetLocalWorkGroup.Status != NET_STATUS_NOTHING)
  {
    if (WinMessages->contentCount+5 > WinMessages->contentMax)
    {
      WIN_deleteItem (WinMessages, 0);
      WinMessages->contentCur--;
      WinMessages->contentStart--;
    }
    while (((i = NET_ReceiveEveryone ( (void *) &SD, sizeof SD)) != -1))
    {
      k = 0;
      if (WinMessages->content [WinMessages->contentCur].type == WIN_ITEMT_INPUT2)
      {
        k = 1;
      }
      InsertMessage (NetLocalWorkGroup.Users [i].Name,
                    SD.Mes, "A message", MESSAGE_EXTERN);
      if (k)
      {
        WinMessages->contentCur++;
        WIN_scrollEnd (WinMessages);
      }
      j++;
    }
    if (j)
    {
      WIN_printContent (WinMessages, WinMessages->contentStart);
      WIN_redrawScreen ();
    }
  }
  else
  {
    WIN_deleteContent (WinMessages);
    WIN_printContent (WinMessages, 0);
  }
}


static void WaitBegin ()
{
  WIN_open/*Passive*/ (WinWait);
  WIN_redrawScreen ();
}

static void WaitEnd ()
{
  WIN_close (WinWait);
  WIN_redrawScreen ();
}



static void Error (int errnum, char *errstr)
{
  #define ERRORSPACE "   "
  char estr [WIN_ITEMLEN];
  strcpy (estr, ERRORSPACE);
  strcat (estr, errstr);

  WIN_deleteContent (WinError);
  WIN_appendComment (WinError, "");
  WIN_appendComment (WinError, ERRORSPACE"An error has occured.");
  WIN_appendComment(WinError, "");
  WIN_appendComment(WinError, estr);
  WIN_appendComment(WinError, "");
  WIN_appendComment(WinError, "");
  WIN_appendComment(WinError, ERRORSPACE"< Press Escape to continue >");
  WIN_appendComment(WinError, "");
  WIN_exec (WinError);
}

static void Confirm (/*char *errtitle,*/ char *errdesc)
{
  WIN_deleteContent (WinConfirm);
  WIN_appendComment (WinConfirm, errdesc);
  WinConfirm->contentCur = WIN_appendMenu (WinConfirm, "Press Enter to continue\n","", 0, NULL, -1);
  WIN_exec (WinConfirm);
}


static void NetInfo (void)
{
  int i;

  DisplayWorkGroups ();
  DisplayUsers ();
  WIN_printContent (WinWorkGroups, 0);
  WIN_printContent (WinUsers, 0);
}


static int NetHandler (void)
{
  int exitcode = 0;
  int i = NET_Update ();

  switch (i)
  {
    case 0:
    {
      break;
    }

    case NET_UPDATE_LOGOUT_MASTER:
    {
      netslog = NETS_LOG_NONE;
      Confirm ("The workgroup was terminated by the master.");
      WinSelected = WinWorkGroups;
      exitcode = -1;
      break;
    }
    case NET_UPDATE_CLEARED_U:
    {
      netslog = NETS_LOG_NONE;
      Confirm ("Your connection has been cleared by the master.");
      WinSelected = WinWorkGroups;
      exitcode = -1;
      break;
    }

    case NET_UPDATE_MISCINFO:
    {
      // check if session has started up
      if (NetLocalWorkGroup.Status == NET_STATUS_STARTUP)
      {
        exitcode = -1;
        netslog = NETS_LOG_STARTUP;
        break;
      }
    }
  }

  if (i!=0)
  {
    NetInfo ();
    WIN_redrawScreen ();
  }
  DisplayMessages ();

  return exitcode;
}



int YesNo (char *Title, int X = -1, int Y = -1)
{
  int com;

  WIN_setTitle (WinYesNo, Title);
  WIN_setBounds (WinYesNo, X, Y, strlen (Title)+4, 4);
  WinYesNo->contentCur = 0;
  com = WIN_exec (WinYesNo);
  return ((com == WIN_COM_ENTER) && (WinYesNo->contentCur == 0));
}


static void Logout ()
{
  WaitBegin ();
  NET_Logout ();
  netslog = NETS_LOG_NONE;
  WaitEnd ();
  NetInfo ();
  WIN_deleteContent (WinMessages);
  WIN_printContent (WinMessages, 0);
  WinSelected = WinWorkGroups;
}

static void Logout_ ()
{
  switch (netslog)
  {
    case NETS_LOG_SLAVE:
    {
      if (YesNo (" Logout ? "))
      {
        Logout ();
      }
      break;
    }
    case NETS_LOG_MASTER:
    {
      if (YesNo (" Terminate work group ? "))
      {
        Logout ();
      }
      break;
    }
  }
}

static void InsertLocalMessage ()
{
  InsertMessage (NET_WhatsMyName (), "", "Enter message", MESSAGE_LOCAL);
  WIN_scrollEnd (WinMessages);
}



int NETS_Setup () // returns 0 - no network, 1 - master, 2 - slave
{
  int i,j;
  int UpdateResult;
  char key;
  int com;
  int exitmain = -1;
  long sended ;
  long received;
  int net;
  SData SD;

  TIPXAddress *MyAddress;

  #ifdef VIDEO_MODE
  TSPRITE *spr;
  short pakHandle;
  TRGBColor pal [256];
  memset (pal, 0, sizeof pal);
  if (SVGA_init () & VESA_COMPATIBLE)
  {
    pakHandle = PAK_open (PAK_FILESPEC_EMU);
    spr = SPRITE_new (pakHandle, "desktop.spr");
    SVGA_setVideoMode (VIDEO_MODE);
    TM_font = FONT_new (pakHandle, "console.fon");
    FONT_updateColors (TM_font, pal);
//    SPRITE_updateColors (spr, pal);

    PAL_set (pal);
  }
  else
  {
    printf ("VESA compatible videocard required.\n");
    return -1;
  }
  #else
    #ifdef VIDEO_MODE0
      SVGA_setVideoMode (0);
    #else
      SVGA_setVideoMode (3);
    #endif
  #endif

  MOUSE_init ();

  if (WIN_init () != -1)
  {
    WIN_setDesktop ('', 31, NULL);
    WIN_setDefaultMiniHelp (MyDefaultMiniHelp);

    WinAbout = WIN_new (2, WIN_NONEFRAME);
//    WIN_setNoneFrame (WinAbout);
    WIN_setBounds (WinAbout, 0, 0, TM_length, 1);
    WIN_setColors (WinAbout, BLACK + B_LIGHTGRAY, BLACK + B_LIGHTGRAY,
    BLACK + B_LIGHTGRAY, BLACK + B_LIGHTGRAY,
    BLACK + B_LIGHTGRAY, BLACK + B_LIGHTGRAY, BLACK + B_LIGHTGRAY);

    WIN_appendComment (WinAbout, " Sky Trail Network Setup Version 0.1"
			      "     Copyright (C) 1996 Action Excel Inc.");
    WIN_open (WinAbout);

    MyWinMiniStatus = WIN_new (2, WIN_NONEFRAME);
//    WIN_setNoneFrame (MyWinMiniStatus);
    WIN_setBounds (MyWinMiniStatus, 0, 22, TM_length, 2);
    WIN_setColors (MyWinMiniStatus, LIGHTGRAY + B_BLACK, LIGHTGRAY + B_BLACK,
    LIGHTGRAY + B_BLACK, LIGHTGRAY + B_BLACK,
    LIGHTGRAY + B_BLACK, LIGHTGRAY + B_BLACK,
    LIGHTGRAY + B_BLACK);

    WIN_setMiniStatusWin (MyWinMiniStatus);

    MyWinMiniHelp = WIN_new (2, WIN_NONEFRAME);
    WIN_setBounds (MyWinMiniHelp, 0, 24, TM_length, 1);
    WIN_setColors (MyWinMiniHelp, B_LIGHTGRAY + BLACK, B_LIGHTGRAY + BLACK,
				  B_LIGHTGRAY + BLACK, B_LIGHTGRAY + BLACK,
				  B_LIGHTGRAY + BLACK, B_LIGHTGRAY + BLACK,
				  B_LIGHTGRAY + BLUE);

    WIN_setMiniHelpWin (MyWinMiniHelp);
    WIN_redrawScreen ();

    WinWait = WIN_new (3, WIN_FRAME);
    WIN_setBounds (WinWait, -1, -1, 12, 5);
    WIN_setColors (WinWait, WHITE + B_BLUE + B_BLINK, YELLOW + B_BLUE,
				    YELLOW + B_BLUE, BLUE + B_LIGHTGRAY,
				    YELLOW + B_BLUE, BLUE + B_LIGHTGRAY,
				    BLUE + B_LIGHTGRAY);
    WIN_appendComment (WinWait, "");
    WIN_appendComment (WinWait, " Wait ... ");

    WinError = WIN_new (8, WIN_FRAME);
    WIN_setTitle (WinError, " Error ");
    WIN_setBounds (WinError, -1, -1, TM_length-2, 8);
    WIN_setColors (WinError, WHITE + B_RED, WHITE + B_RED,
    WHITE + B_RED, WHITE + B_RED, WHITE + B_RED, WHITE + B_RED, WHITE + B_RED);

    WinError->commsAvail.enter = 0;
    WinError->commsAvail.f10 = 0;

    WinConfirm = WIN_new (2, WIN_FRAME);
    WIN_setTitle (WinConfirm, " Note ");
    WIN_setBounds (WinConfirm, 12, 10, 50, 2);
    WIN_setColors (WinConfirm, WHITE + B_RED, WHITE + B_RED,
			       WHITE + B_RED, WHITE + B_LIGHTGRAY,
			       WHITE + B_LIGHTGRAY, WHITE + B_LIGHTGRAY,
			       WHITE + B_LIGHTGRAY);

    // init the main window

    WaitBegin ();

    net = NET_Init ();

    WaitEnd ();

    #ifdef DEBUG_NONET
      net = 1;
    #endif

    if (!net)
    {
      Error (-1, "An IPX compatible network\n"
		 "   has been not found.");
    }
    else
    {
      WinYesNo = WIN_new (2, WIN_FRAME);
      WIN_setColors (WinYesNo, 79, 79, 79, 127, 127, 127, 127);
      WIN_appendMenu (WinYesNo, "", " Yes\n", -1,
				       "Yes", -1);
      WIN_appendMenu (WinYesNo, ""," No\n", -1,
				      "No", -1);

      WinMessages = WIN_new (1000, WIN_FRAME);
      WIN_setTitle (WinMessages, " Messages ");
      WinMessages->commsAvail.tab = 1;
      WinMessages->commsAvail.del = 1;
      WIN_scrollBarEnable (WinMessages);
      WIN_setBounds (WinMessages, 0, 7, TM_length, 15);
      WIN_setColors (WinMessages, BLUE + B_CYAN, BLUE + B_CYAN,
				  BLUE + B_CYAN, LIGHTCYAN + B_GREEN,
				  LIGHTCYAN + B_GREEN,LIGHTCYAN + B_GREEN,
				  LIGHTCYAN + B_GREEN);
      WIN_open (WinMessages);

      WinWorkGroups = WIN_new (10, WIN_FRAME);
      WIN_setTitle (WinWorkGroups, " Workgroups ");
      WinWorkGroups->commsAvail.tab = 1;
      WinWorkGroups->commsAvail.ins = 1;
      WinWorkGroups->commsAvail.del = 1;
      WIN_scrollBarEnable (WinWorkGroups);
      WIN_setBounds (WinWorkGroups, 0, 1, TM_length/2, 6);
      WIN_setColors (WinWorkGroups, WHITE + B_BLUE, YELLOW + B_BLUE,
				    YELLOW + B_BLUE, BLUE + B_LIGHTGRAY,
				    BLUE + B_LIGHTGRAY, BLUE + B_LIGHTGRAY,
				    BLUE + B_LIGHTGRAY);
      WIN_open (WinWorkGroups);

      WinUsers = WIN_new (10, WIN_FRAME);
      WIN_setTitle (WinUsers, " Users ");
      WinUsers->commsAvail.del = 1;
      WinUsers->commsAvail.tab = 1;
      WIN_scrollBarEnable (WinUsers);
      WIN_setBounds (WinUsers, TM_length/2, 1, TM_length/2, 6);
      WIN_setColors (WinUsers, WHITE + B_BLUE, YELLOW + B_BLUE,
			       YELLOW + B_BLUE, BLUE + B_LIGHTGRAY,
			       BLUE + B_LIGHTGRAY , BLUE + B_LIGHTGRAY,
			       BLUE + B_LIGHTGRAY);

      WIN_open (WinUsers);

      WinMain = WIN_new (20, WIN_NONEFRAME);
      WIN_setBounds (WinMain,  0, 1, 40, 23);
      WIN_setColors (WinMain,  WHITE + B_BLUE, YELLOW + B_BLUE,
			       YELLOW + B_BLUE, BLUE + B_LIGHTGRAY,
			       BLUE + B_LIGHTGRAY , BLUE + B_LIGHTGRAY,
			       BLUE + B_LIGHTGRAY);

//      WIN_insertSubWin (WinMain, WinMessages);
//      WIN_insertSubWin (WinMain, WinWorkGroups);
//      WIN_insertSubWin (WinMain, WinUsers);
//      WIN_open (WinMain);

      WIN_redrawScreen ();

      NetInfo ();
      WIN_setWaitHandler (NetHandler);

      WinSelected = WinWorkGroups;
      do
      {
        com = WIN_insert (WinSelected);
        if (netslog == NETS_LOG_STARTUP)
        {
          exitmain = 2;
          break;
        }

        switch (com)
	{
          case WIN_COM_ESC:  // exit setup
          {
            if (YesNo (" Exit network setup ? "))
            {
              Logout ();
              exitmain = 0;
            }
            break;
          }
          case WIN_COM_EXIT:  // exit setup
          {
            if ((NetLocalWorkGroup.Status != NET_STATUS_NOTHING) && (netslog == NETS_LOG_MASTER))
            {
              if (YesNo (" Startup ? "))
              {
                NET_Startup ();
                exitmain = 1;
              }
            }
            break;
          }

          default:
          {
            if (WinSelected == WinWorkGroups)
            {
              switch (com)
              {
                case WIN_COM_ENTER: // create or join a workgroup
                {
                  if (netslog == NETS_LOG_NONE)
                  {
                    i = WinWorkGroups->content [WinWorkGroups->contentCur].value;
                    strcpy (GName, WinWorkGroups->content [WinWorkGroups->contentCur].item);
                    GName [WIN_strlen (GName)] = 0;
                    if ((i == 0) || (strcmp (GName, NetWorkGroup [i].Desc) == 0))
                    {
                      WinSelected = WinUsers;
                      WIN_deleteContent (WinUsers);
                      WinUsers->selectable = 1;
		      WIN_insertItem (WinUsers, 0, WIN_ITEMT_INPUT2, "", "", -1, "Your name", -1);
                      WinUsers->commsAvail.tab = 0;

                      if (WinWorkGroups->contentCur == 0)
                      {
                        netslog=NETS_LOG_CREATE;
                      }
                      else
                      {
                        netslog=NETS_LOG_JOIN;
                      }
                    }
                  }
                  break;
                }
                case WIN_COM_DEL:
                {
                  Logout_ ();
                  break;
                }
                case WIN_COM_TAB:   // cycle Wins
                {
                  if (netslog != NETS_LOG_NONE)
                    WinSelected = WinUsers;
                  break;
                }
              }
            }
            else
            if (WinSelected == WinUsers)
            {
              switch (com)
              {
                case WIN_COM_ENTER: // send a message
                {
                  if (WinUsers->content [WinUsers->contentCur].type == WIN_ITEMT_INPUT2)
                  {
                    strcpy (PName, WinUsers->content [WinUsers->contentCur].item);
                    PName [WIN_strlen (PName)] = 0;
                    //WIN_deleteItem (WinUsers, 0);
                    //WIN_insertItem (WinUsers, -1, "", PName);
                    //WIN_printContent (WinUsers);
                    WinUsers->commsAvail.tab = 1;
                    switch (netslog)
                    {
                      case NETS_LOG_CREATE:
                        NET_Create (GName, PName, "");
                        netslog = NETS_LOG_MASTER;
                        NetInfo ();
                        break;
                      case NETS_LOG_JOIN:
                        NET_Join (WinWorkGroups->contentCur-1, PName, "");
                        WinWorkGroups->contentCur = 0;
                        netslog = NETS_LOG_SLAVE;
                        NetInfo ();
                        break;
                    }
                    WinSelected=WinMessages;
                    InsertLocalMessage ();
                  }
                  break;
                }
                case WIN_COM_DEL:   // logout user (master only)
                {
                  switch (NetLocalWorkGroup.User)
                  {
                    case NET_USER_MASTER:
                    {
                      if (WinUsers->contentCur != 0)
                      {
                        if (YesNo (" Delete user ? "))
                        {
                          NET_ClearSlave (WinUsers->contentCur);
                          NetInfo ();
                        }
                      }
                      else
                      {
                        Logout_ ();
                      }
                      break;
                    }
                    default:
                    {
                      Logout_ ();
                      break;
                    }
                  }
                  break;
                }
                case WIN_COM_TAB:   // cycle Wins
                {
                  if ((netslog == NETS_LOG_MASTER) || (netslog == NETS_LOG_SLAVE))
                    WinSelected = WinMessages;
                  else
                    WinSelected = WinWorkGroups;
                  break;
                }
              }
            }
            else
            if (WinSelected == WinMessages)
            {
              switch (com)
              {
                case WIN_COM_ENTER: // send a broadcast message
                {
                  if (WinMessages->content [WinSelected->contentCur].type == WIN_ITEMT_INPUT2)
                  {
                    WIN_changeItemType (WinMessages, WinMessages->contentCur,
                                      WIN_ITEMT_MENU);
                    strcpy (SD.Mes, WinSelected->content [WinSelected->contentCount-1].item);
                    InsertLocalMessage ();
                    NET_SendEveryone ((void *) &SD, sizeof SD);
                  }

                  break;
                }
                case WIN_COM_TAB:   // cycle Wins
                {
                  WinSelected = WinWorkGroups;
                  break;
                }
                case WIN_COM_DEL:
                {
                  WIN_deleteItem (WinMessages, WinMessages->contentCur);
                  WIN_printContent (WinMessages, 0);
                  break;
                }
              }
            }
          }
        }
      }
      while (exitmain == -1);

      // NET_Done ();
    }
    WIN_closeAll ();

    WIN_done ();

    WIN_delete (MyWinMiniHelp);
    WIN_delete (MyWinMiniStatus);

    WIN_delete (WinWorkGroups);
    WIN_delete (WinUsers);
    WIN_delete (WinStatus);
    WIN_delete (WinMessages);

    WIN_delete (WinYesNo);
    WIN_delete (WinAbout);
    WIN_delete (WinMain);
    WIN_delete (WinError);
    WIN_delete (WinConfirm);
    WIN_delete (WinWait);

    WIN_delete (WinSelected);
    WIN_done ();
  }

  SVGA_done ();

  return exitmain;
}
