
#include <stdlib.h>

#include "cgdk.h"
#include "array.h"

long AL_find (long *array, long item, long alen)
{
  long i;

  for (i = 0; i < alen; i++)
  {
    if (array [i] == item)
      return i;
  }
  return -1;
}


long AL_insert (long *array, long item, long alen)
{
  long i;

  i = AL_find (array, NULL, alen);
  if (i != -1)
    array [i] = item;
  return i;
}


long AL_delete (long *array, long item, long alen)
{
  long i,j;

  i = AL_find (array, item, alen);
  if (i != -1)
    array [i] = NULL;
  j = i;
  while (array [j+1] != NULL)
  {
    array [j] = array [j+1];
    j++;
  }
  array [j] = NULL;
  return i;
}


long AL_findNum (long *array, long itemNum, long alen)
{
  long i;

  for (i = 0; i < alen; i++)
  {
    if (array [i] != NULL)
      itemNum--;
    if (itemNum == -1)
      return i;
  }
  return -1;
}


short *A_char2short (char *charArray, long n)
{
  short *a;
  long i;

  a = (short *) _alloc (2*n);

  if (a)
  {
    for (i = 0; i < n; i++)
    {
      a [i] = charArray [i];
    }
  }
  return a;
}
